//+------------------------------------------------------------------+
//|                                                   MA_Dinamic.mq4 |
//|                  |
//|                                             |
//|  :                                               |
//|   : 15.09.2010                                   |
//|   : 15.09.2010                                |
//+------------------------------------------------------------------+
//|  :                                                      |
//|         maxMA     -    MA                 |
//|         minMA     -    MA                  |
//|         variator  -                   |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "9382396@mail.ru"

#property indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Aqua
#property  indicator_width1 1
//---- indicator parameters
extern int maxMA=100;      //    MA
extern int minMA=1;        //    MA
extern double variator=8;  //   ,      MA  
                           //    MA   maxMA.   -   MA   minMA,   -    maxMA.
//extern int dlina=2000;   //  ,    ,    dlina ,  0 -  

//---- indicator buffers
double     MaBuffer1[];
double     MaBuffer2[];

int counted_bars=0;
int preBars,preLeft;
int j=0;
double sumNakl =0;
double max_naklon=1000;
double sglad = 10;


int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,maxMA-1);
   SetIndexBuffer(0,MaBuffer1);
   IndicatorShortName("MA Dinamic("+maxMA+")");
   SetIndexLabel(0,"MA Dinamic("+maxMA+")");
   preBars=Bars;
   preLeft=Bars;

   return(0);
  }
  
  void deinit() 
  {Comment("");}
  
int start()
  {
   if(Bars<=maxMA) return(0);
   double cur,prev,nakl,mc;
   int limit,MAcur;
   counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-counted_bars-1;
   if (counted_bars<maxMA) limit-=maxMA;
   //if (limit>dlina && dlina>0) limit=dlina;

   for(int i=limit; i>=0; i--)
      {
      prev=iMA(NULL,0,maxMA,0,MODE_SMA,PRICE_CLOSE,i+1);
      cur =iMA(NULL,0,maxMA,0,MODE_SMA,PRICE_CLOSE,i);
      nakl=MathAbs(prev-cur)/Point;
      j++;
      sumNakl+=nakl;
      max_naklon = variator*sumNakl/j;
      if (max_naklon!=0) nakl= nakl/max_naklon;
      if (nakl>1) nakl=1;
      MAcur=MathRound(maxMA*(1-nakl));//MathSqrt(1-nakl*nakl));
      if (MAcur<minMA) MAcur=minMA;
      if ((i+MAcur)>(preLeft+Bars-preBars)) MAcur=preLeft+Bars-preBars-i;
      preLeft=i+MAcur;
      preBars=Bars;
      
      MaBuffer2[i]=iMA(NULL,0,MAcur,0,MODE_SMA,PRICE_CLOSE,i);
      if (i==limit) MaBuffer1[i]=iMA(NULL,0,MAcur,0,MODE_SMA,PRICE_CLOSE,i);
      if (i<limit) {
        mc =MaBuffer1[i+1]+(iMA(NULL,0,MAcur,0,MODE_SMA,PRICE_CLOSE,i)-iMA(NULL,0,MAcur,0,MODE_SMA,PRICE_CLOSE,i+1));
        MaBuffer1[i]=mc+(iMA(NULL,0,MAcur,0,MODE_SMA,PRICE_CLOSE,i)-mc)/sglad;
        }
      }
   return(0);
  }
//+------------------------------------------------------------------+